if Network:is_client() then
	return
end

if not Global.game_settings or Global.game_settings.level_id ~= 'nmh' then
	return
end

EnemyManager = EnemyManager or class()

function EnemyManager:register_civilian(unit)
	unit:base():add_destroy_listener(self._unit_clbk_key, callback(self, self, "on_civilian_destroyed"))
	self:_create_unit_gfx_lod_data(unit, true)

	if tostring(unit):sub(11,26) == '38815917ecde65e9' then

		local old_on_alert = unit:brain()._current_logic.on_alert
		local new_on_alert = function(data, alert_data)
									if tostring(data.unit):sub(11,26) == '38815917ecde65e9' then
										return
									else
										old_on_alert(data, alert_data)
									end
							end
		unit:brain()._current_logic.on_alert = new_on_alert
		local old_on_intimidated = unit:brain()._current_logic.on_intimidated
		local new_on_intimidated = function(data, amount, aggressor_unit)
									if tostring(data.unit):sub(11,26) == '38815917ecde65e9' then
										_G.NMHS:alerted_vip()
									else
										old_on_intimidated(data, amount, aggressor_unit)
									end
							end
		unit:brain()._current_logic.on_intimidated = new_on_intimidated

	end

	local char_tweak = tweak_data.character[unit:base()._tweak_table]

	local factor = 0.5 - #managers.network:session():peers() * 0.1
	char_tweak.scare_max = {10 * factor, 20 * factor}
	char_tweak.scare_shot = factor
	char_tweak.scare_intimidate = -5 / factor
	char_tweak.submission_max = {60 * factor, 120 * factor}
	char_tweak.submission_intimidate = 120 * factor
	char_tweak.run_away_delay = {10^5, 10^5}

	self._civilian_data.unit_data[unit:key()] = {
		is_civilian = true,
		unit = unit,
		m_pos = unit:movement():m_pos(),
		tracker = unit:movement():nav_tracker(),
		char_tweak = char_tweak,
		so_access = managers.navigation:convert_access_flag(char_tweak.access)
	}
end

function EnemyManager:on_civilian_died(dead_unit, damage_info)
	if tostring(dead_unit):sub(11,26) == '38815917ecde65e9' then
		_G.NMHS:alerted_vip()
	end

	local u_key = dead_unit:key()

	managers.groupai:state():on_civilian_unregistered(dead_unit)

	if Network:is_server() and damage_info.attacker_unit and not dead_unit:base().enemy then
		managers.groupai:state():hostage_killed(damage_info.attacker_unit)
	end

	managers.mission:call_global_event("civilian_killed")

	local u_data = self._civilian_data.unit_data[u_key]
	local enemy_data = self._enemy_data

	if enemy_data.nr_corpses == 0 and self:is_corpse_disposal_enabled() then
		self:queue_task("EnemyManager._upd_corpse_disposal", EnemyManager._upd_corpse_disposal, self, self._t + self._corpse_disposal_upd_interval)
	end

	enemy_data.nr_corpses = enemy_data.nr_corpses + 1
	enemy_data.corpses[u_key] = u_data
	u_data.death_t = TimerManager:game():time()
	self._civilian_data.unit_data[u_key] = nil

	self:_destroy_unit_gfx_lod_data(u_key)

	u_data.u_id = dead_unit:id()

	if self:is_corpse_disposal_enabled() then
		Network:detach_unit(dead_unit)
	end

	managers.hud:remove_waypoint("wp_hostage_trade" .. tostring(dead_unit:key()))
end