if Network:is_client() then
	return
end

if not Global.game_settings or Global.game_settings.level_id ~= 'nmh' then
	return
end

core:module("CoreElementRandom")
core:import("CoreMissionScriptElement")
core:import("CoreTable")

ElementRandom = ElementRandom or class(CoreMissionScriptElement.MissionScriptElement)

function ElementRandom:on_executed(instigator)
	if not self._values.enabled then
		return
	end

	local id = tostring(self._id)
	local events_exec = 0
	if id == '103762' then
		_G.NMHS.phone_interacted_cnt = _G.NMHS.phone_interacted_cnt + 1
		if _G.NMHS.phone_interacted_cnt > 5 then
			_G.NMHS.phone_completed_org = true --activate continuous phone call
		end
	end

	if _G.NMHS.phone_completed_org and (id  == '103762' or id == '102687') then
		self._values.ignore_disabled = false --run disabled events on continuous phone call
	end

	if id == '102687' then
		_G.NMHS.phone_dialog_np_cnt = _G.NMHS.phone_dialog_np_cnt + 1 --count "no problem" events
	end

	self._unused_randoms = {}

	for i, element_data in ipairs(self._original_on_executed) do
		if not self._values.ignore_disabled or self._values.ignore_disabled and self:get_mission_element(element_data.id):enabled() then
			if id == '103762' then
				if _G.NMHS.phone_completed_org then
					if element_data.id == 102687 or  element_data.id == 102697 then --allow only "no problem" and new civ spawn events
						table.insert(self._unused_randoms, i)
					end
				else
					if element_data.id == 102687 and _G.NMHS.phone_dialog_np_cnt >=2 then
						--don't execute np more than twice
					elseif element_data.id == 102697 and not _G.NMHS.phone_civ_event then
						--don't execute civ spawn more than once in first round
					else
						table.insert(self._unused_randoms, i)
					end
				end
			else
				table.insert(self._unused_randoms, i)
			end	
		end
	end

	self._values.on_executed = {}
	local amount = self:_calc_amount()

	if self._values.counter_id then
		local element = self:get_mission_element(self._values.counter_id)
		amount = element:counter_value()
	end

	for i = 1, math.min(amount, #self._original_on_executed), 1 do
		table.insert(self._values.on_executed, self._original_on_executed[self:_get_random_elements()])
	end

	if id == '103762' then
		if self._values.on_executed[1].id == 102697 then
			_G.NMHS.phone_civ_event = false --manually disable event for first round
		end
	end

	ElementRandom.super.on_executed(self, instigator)
end